#!/bin/sh
# execute arguments then prompt for input before exiting/re-running etc
PATH=$PATH:$HOME/bin.`uname -s`
export PATH

case `echo 'x\c'` in
*c)
	EOPT=-n
	ESTR=
	;;
*)
	EOPT=
	ESTR='\c'
	;;
esac
if [ $# = 0 ]
then
	echo $EOPT "> $ESTR"
	read c
	set -- $c
fi
while :
do
	if [ -n "$*" ]
	then
		trap "" 2
		date
		echo '+' "$@"
		execlp -i -- "$@"
		stat=$?
	fi
	trap "echo $EOPT '> $ESTR'; read c; set -- \$c" 2
	echo
	date
	echo "EOF TO EXIT, INTR FOR NEW CMD, RETURN TO RE-RUN: $*"
	until read x; do
		exit $stat
	done
done
