#include <stdio.h>
#include <signal.h>

main(argc, argv)
char **argv;
{
	extern int optind;
	extern char *optarg;
	int optch, uid = -1;
	char *prog=NULL;

	while ((optch=getopt(argc, argv, "u:p:i")) != -1)
		switch (optch) {
		case 'i':
			signal(SIGINT, SIG_DFL);
			signal(SIGQUIT, SIG_DFL);
			break;
		case 'p':
			prog=optarg;
			break;
		case 'u':
			uid=atoi(optarg);
			break;
		default:
usage:
			fprintf(stderr, "Usage: %s [-p<prog>][-i][-u<setuid>] <argv0> [<args>]...\n", *argv);
			exit(1);
		}
	if (optind == argc)
		goto usage;

	if (prog == NULL)
		prog=argv[optind];
	if (uid != -1 && setuid(uid) == -1) {
		perror(prog);
		exit(1);
	}
	execvp(prog, &argv[optind]);
	perror(prog);
	exit(1);
}
